// Code generated - DO NOT EDIT.
// This file is a generated binding and any manual changes will be lost.

package buildparam

import (
	"errors"
	"math/big"
	"strings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// Reference imports to suppress errors if they are not otherwise used.
var (
	_ = errors.New
	_ = big.NewInt
	_ = strings.NewReader
	_ = ethereum.NotFound
	_ = bind.Bind
	_ = common.Big1
	_ = types.BloomLookup
	_ = event.NewSubscription
)

// IPancakePermitDetails is an auto generated low-level Go binding around an user-defined struct.
type IPancakePermitDetails struct {
	Token      common.Address
	Amount     *big.Int
	Expiration *big.Int
	Nonce      *big.Int
}

// IPancakePermitSingle is an auto generated low-level Go binding around an user-defined struct.
type IPancakePermitSingle struct {
	Details     IPancakePermitDetails
	Spender     common.Address
	SigDeadline *big.Int
}

// ParamContractMetaData contains all meta data concerning the ParamContract contract.
var ParamContractMetaData = &bind.MetaData{
	ABI: "[{\"inputs\":[{\"components\":[{\"components\":[{\"internalType\":\"address\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"uint160\",\"name\":\"amount\",\"type\":\"uint160\"},{\"internalType\":\"uint48\",\"name\":\"expiration\",\"type\":\"uint48\"},{\"internalType\":\"uint48\",\"name\":\"nonce\",\"type\":\"uint48\"}],\"internalType\":\"structIPancake.PermitDetails\",\"name\":\"details\",\"type\":\"tuple\"},{\"internalType\":\"address\",\"name\":\"spender\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"sigDeadline\",\"type\":\"uint256\"}],\"internalType\":\"structIPancake.PermitSingle\",\"name\":\"permitSingle\",\"type\":\"tuple\"},{\"internalType\":\"bytes\",\"name\":\"data\",\"type\":\"bytes\"}],\"name\":\"buildParamPermit2\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"recipient\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"amountIn\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"amountOutMin\",\"type\":\"uint256\"},{\"internalType\":\"bytes\",\"name\":\"path\",\"type\":\"bytes\"},{\"internalType\":\"bool\",\"name\":\"playerIsUser\",\"type\":\"bool\"}],\"name\":\"buildParamV3_SWAP_EXACT_IN\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"bytes\",\"name\":\"commands\",\"type\":\"bytes\"},{\"internalType\":\"bytes[]\",\"name\":\"inputs\",\"type\":\"bytes[]\"},{\"internalType\":\"uint256\",\"name\":\"deadline\",\"type\":\"uint256\"}],\"name\":\"execute\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"}]",
}

// ParamContractABI is the input ABI used to generate the binding from.
// Deprecated: Use ParamContractMetaData.ABI instead.
var ParamContractABI = ParamContractMetaData.ABI

// ParamContract is an auto generated Go binding around an Ethereum contract.
type ParamContract struct {
	ParamContractCaller     // Read-only binding to the contract
	ParamContractTransactor // Write-only binding to the contract
	ParamContractFilterer   // Log filterer for contract events
}

// ParamContractCaller is an auto generated read-only Go binding around an Ethereum contract.
type ParamContractCaller struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ParamContractTransactor is an auto generated write-only Go binding around an Ethereum contract.
type ParamContractTransactor struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ParamContractFilterer is an auto generated log filtering Go binding around an Ethereum contract events.
type ParamContractFilterer struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ParamContractSession is an auto generated Go binding around an Ethereum contract,
// with pre-set call and transact options.
type ParamContractSession struct {
	Contract     *ParamContract    // Generic contract binding to set the session for
	CallOpts     bind.CallOpts     // Call options to use throughout this session
	TransactOpts bind.TransactOpts // Transaction auth options to use throughout this session
}

// ParamContractCallerSession is an auto generated read-only Go binding around an Ethereum contract,
// with pre-set call options.
type ParamContractCallerSession struct {
	Contract *ParamContractCaller // Generic contract caller binding to set the session for
	CallOpts bind.CallOpts        // Call options to use throughout this session
}

// ParamContractTransactorSession is an auto generated write-only Go binding around an Ethereum contract,
// with pre-set transact options.
type ParamContractTransactorSession struct {
	Contract     *ParamContractTransactor // Generic contract transactor binding to set the session for
	TransactOpts bind.TransactOpts        // Transaction auth options to use throughout this session
}

// ParamContractRaw is an auto generated low-level Go binding around an Ethereum contract.
type ParamContractRaw struct {
	Contract *ParamContract // Generic contract binding to access the raw methods on
}

// ParamContractCallerRaw is an auto generated low-level read-only Go binding around an Ethereum contract.
type ParamContractCallerRaw struct {
	Contract *ParamContractCaller // Generic read-only contract binding to access the raw methods on
}

// ParamContractTransactorRaw is an auto generated low-level write-only Go binding around an Ethereum contract.
type ParamContractTransactorRaw struct {
	Contract *ParamContractTransactor // Generic write-only contract binding to access the raw methods on
}

// NewParamContract creates a new instance of ParamContract, bound to a specific deployed contract.
func NewParamContract(address common.Address, backend bind.ContractBackend) (*ParamContract, error) {
	contract, err := bindParamContract(address, backend, backend, backend)
	if err != nil {
		return nil, err
	}
	return &ParamContract{ParamContractCaller: ParamContractCaller{contract: contract}, ParamContractTransactor: ParamContractTransactor{contract: contract}, ParamContractFilterer: ParamContractFilterer{contract: contract}}, nil
}

// NewParamContractCaller creates a new read-only instance of ParamContract, bound to a specific deployed contract.
func NewParamContractCaller(address common.Address, caller bind.ContractCaller) (*ParamContractCaller, error) {
	contract, err := bindParamContract(address, caller, nil, nil)
	if err != nil {
		return nil, err
	}
	return &ParamContractCaller{contract: contract}, nil
}

// NewParamContractTransactor creates a new write-only instance of ParamContract, bound to a specific deployed contract.
func NewParamContractTransactor(address common.Address, transactor bind.ContractTransactor) (*ParamContractTransactor, error) {
	contract, err := bindParamContract(address, nil, transactor, nil)
	if err != nil {
		return nil, err
	}
	return &ParamContractTransactor{contract: contract}, nil
}

// NewParamContractFilterer creates a new log filterer instance of ParamContract, bound to a specific deployed contract.
func NewParamContractFilterer(address common.Address, filterer bind.ContractFilterer) (*ParamContractFilterer, error) {
	contract, err := bindParamContract(address, nil, nil, filterer)
	if err != nil {
		return nil, err
	}
	return &ParamContractFilterer{contract: contract}, nil
}

// bindParamContract binds a generic wrapper to an already deployed contract.
func bindParamContract(address common.Address, caller bind.ContractCaller, transactor bind.ContractTransactor, filterer bind.ContractFilterer) (*bind.BoundContract, error) {
	parsed, err := abi.JSON(strings.NewReader(ParamContractABI))
	if err != nil {
		return nil, err
	}
	return bind.NewBoundContract(address, parsed, caller, transactor, filterer), nil
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_ParamContract *ParamContractRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _ParamContract.Contract.ParamContractCaller.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_ParamContract *ParamContractRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _ParamContract.Contract.ParamContractTransactor.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_ParamContract *ParamContractRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _ParamContract.Contract.ParamContractTransactor.contract.Transact(opts, method, params...)
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_ParamContract *ParamContractCallerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _ParamContract.Contract.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_ParamContract *ParamContractTransactorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _ParamContract.Contract.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_ParamContract *ParamContractTransactorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _ParamContract.Contract.contract.Transact(opts, method, params...)
}

// BuildParamPermit2 is a paid mutator transaction binding the contract method 0x2c1a2f7a.
//
// Solidity: function buildParamPermit2(((address,uint160,uint48,uint48),address,uint256) permitSingle, bytes data) returns()
func (_ParamContract *ParamContractTransactor) BuildParamPermit2(opts *bind.TransactOpts, permitSingle IPancakePermitSingle, data []byte) (*types.Transaction, error) {
	return _ParamContract.contract.Transact(opts, "buildParamPermit2", permitSingle, data)
}

// BuildParamPermit2 is a paid mutator transaction binding the contract method 0x2c1a2f7a.
//
// Solidity: function buildParamPermit2(((address,uint160,uint48,uint48),address,uint256) permitSingle, bytes data) returns()
func (_ParamContract *ParamContractSession) BuildParamPermit2(permitSingle IPancakePermitSingle, data []byte) (*types.Transaction, error) {
	return _ParamContract.Contract.BuildParamPermit2(&_ParamContract.TransactOpts, permitSingle, data)
}

// BuildParamPermit2 is a paid mutator transaction binding the contract method 0x2c1a2f7a.
//
// Solidity: function buildParamPermit2(((address,uint160,uint48,uint48),address,uint256) permitSingle, bytes data) returns()
func (_ParamContract *ParamContractTransactorSession) BuildParamPermit2(permitSingle IPancakePermitSingle, data []byte) (*types.Transaction, error) {
	return _ParamContract.Contract.BuildParamPermit2(&_ParamContract.TransactOpts, permitSingle, data)
}

// BuildParamV3SWAPEXACTIN is a paid mutator transaction binding the contract method 0xbb232d81.
//
// Solidity: function buildParamV3_SWAP_EXACT_IN(address recipient, uint256 amountIn, uint256 amountOutMin, bytes path, bool playerIsUser) returns()
func (_ParamContract *ParamContractTransactor) BuildParamV3SWAPEXACTIN(opts *bind.TransactOpts, recipient common.Address, amountIn *big.Int, amountOutMin *big.Int, path []byte, playerIsUser bool) (*types.Transaction, error) {
	return _ParamContract.contract.Transact(opts, "buildParamV3_SWAP_EXACT_IN", recipient, amountIn, amountOutMin, path, playerIsUser)
}

// BuildParamV3SWAPEXACTIN is a paid mutator transaction binding the contract method 0xbb232d81.
//
// Solidity: function buildParamV3_SWAP_EXACT_IN(address recipient, uint256 amountIn, uint256 amountOutMin, bytes path, bool playerIsUser) returns()
func (_ParamContract *ParamContractSession) BuildParamV3SWAPEXACTIN(recipient common.Address, amountIn *big.Int, amountOutMin *big.Int, path []byte, playerIsUser bool) (*types.Transaction, error) {
	return _ParamContract.Contract.BuildParamV3SWAPEXACTIN(&_ParamContract.TransactOpts, recipient, amountIn, amountOutMin, path, playerIsUser)
}

// BuildParamV3SWAPEXACTIN is a paid mutator transaction binding the contract method 0xbb232d81.
//
// Solidity: function buildParamV3_SWAP_EXACT_IN(address recipient, uint256 amountIn, uint256 amountOutMin, bytes path, bool playerIsUser) returns()
func (_ParamContract *ParamContractTransactorSession) BuildParamV3SWAPEXACTIN(recipient common.Address, amountIn *big.Int, amountOutMin *big.Int, path []byte, playerIsUser bool) (*types.Transaction, error) {
	return _ParamContract.Contract.BuildParamV3SWAPEXACTIN(&_ParamContract.TransactOpts, recipient, amountIn, amountOutMin, path, playerIsUser)
}

// Execute is a paid mutator transaction binding the contract method 0x3593564c.
//
// Solidity: function execute(bytes commands, bytes[] inputs, uint256 deadline) returns()
func (_ParamContract *ParamContractTransactor) Execute(opts *bind.TransactOpts, commands []byte, inputs [][]byte, deadline *big.Int) (*types.Transaction, error) {
	return _ParamContract.contract.Transact(opts, "execute", commands, inputs, deadline)
}

// Execute is a paid mutator transaction binding the contract method 0x3593564c.
//
// Solidity: function execute(bytes commands, bytes[] inputs, uint256 deadline) returns()
func (_ParamContract *ParamContractSession) Execute(commands []byte, inputs [][]byte, deadline *big.Int) (*types.Transaction, error) {
	return _ParamContract.Contract.Execute(&_ParamContract.TransactOpts, commands, inputs, deadline)
}

// Execute is a paid mutator transaction binding the contract method 0x3593564c.
//
// Solidity: function execute(bytes commands, bytes[] inputs, uint256 deadline) returns()
func (_ParamContract *ParamContractTransactorSession) Execute(commands []byte, inputs [][]byte, deadline *big.Int) (*types.Transaction, error) {
	return _ParamContract.Contract.Execute(&_ParamContract.TransactOpts, commands, inputs, deadline)
}
